//-------------------------------
// Modulo GSM
//
// Coutio Constancio Diana Lizzete
// Ing. Electronica
//
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
char RxTx_SMS[8];        // Buffer para recepcion de SMS
char byte;
unsigned short SMS_Rcvd;   // Indicador de SMS recibido
int sms_cTx = 0;
int sms_cRx = 0;
int sms_bRx = 0;
int i = 0;
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void interrupt() {
if((PIR1.RCIF == 1) && (RCSTA.OERR == 0))    // Interrupcion por recepcion de datos por USART
  {
  byte =  Usart_Read();          // Lectura de Dato
  if (sms_bRx == 1)
     {
     RxTx_SMS[sms_cRx] = byte;
     sms_cRx++;
     }
  if (byte == 'Z')            // Comprobacion y sincronizacion de recepcion de trama de datos necesarios para la decodificacion de ordenes en SMS
     {
     sms_cRx = 0;
     RxTx_SMS[sms_cRx] = byte;
     sms_cRx++;
     sms_bRx = 1;
     }
  if(sms_cRx == 5)        // Comprobacion de finalizacion de recepcion de paquete
     {
     SMS_Rcvd = 1;
     sms_cRx = 0;
     sms_bRx = 0;
     }
  PIR1.RCIF = 0;
  }
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void Init (){
Usart_Init(9600); // Inicializa modulo USART
PORTB.F0 = 0;
TRISB.F0 = 0;
INTCON.GIE = 1;
INTCON.PEIE = 1;      // Inicializacion de interrupciones
PIE1.RCIE = 1;
PIR1.RCIF = 0;
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void main()
{
Init();
while(1){
        if(SMS_Rcvd == 1)  // Determinacion de SMS recibido envio de comando depurado mediante USART
          {
          TRISB.F0 = 1;
          Delay_ms(300);
          TRISB.F0 = 0;
          for(i=0; i<=4; i++)
             {
             Usart_Write(RxTx_SMS[i]);
             Delay_ms (50);
             }
           SMS_Rcvd = 0;
          }
        }
}